<?php

error_reporting(E_ALL);

require_once dirname(__FILE__).'/define.php';

class LinkRoller {

  var $dbh;
  var $content;
  var $message;
  var $admin_url;

  // -------------------------------------------------------------------------------
  function LinkRoller( $args=array() )
  {
	if (! ( isset($this->dbh) && $this->dbh ) )
	{
		// establish a database connection
		// -------------------------------
		$db_selected = 0;

		$this->dbh = @mysql_connect( DB_HOST, DB_USER, DB_PASS );

		if ( isset($this->dbh) && $this->dbh )
		{
			$db_selected = @mysql_select_db( DB_NAME, $this->dbh );
		}
		if ( !$db_selected )
		{
			$this->message = 'Problem: Sorry, we are unable to connect our database...';
			$this->error();
		}
	}

	$this->_init();
  }
  // -------------------------------------------------------------------------------
  function _init()
  {
	// variable initialization
	// -----------------------
	$this->admin_url = './admin.php';

	$tld	= DOMAINNAME;
	$server	= ( isset($_SERVER) && is_array($_SERVER) && array_key_exists('SERVER_NAME',$_SERVER) )
		? $_SERVER['SERVER_NAME'] : '';

	$this->cookie_expire	= time() + 90 * 24 * 60 * 60;	// 90 days
	$this->cookie_path	= '/';
	$this->cookie_domain	= preg_match( '/localhost/', $server, $m ) ? '' : '.'.$tld;
	// -----------------------

	$do      = isset( $_REQUEST['do'] )   ? $_REQUEST['do'] : '';
	$list_id = isset( $_POST['list_id'] ) ? $_POST['list_id'] : 0;

	if ( preg_match( '/(edit|delete)_list/', $do, $m ) && ! $list_id )
	{
		// if not in form, look for in query string
		$list_id = isset( $_GET['list_id'] ) ? $_GET['list_id'] : 0;
	}

	if ( $do && $do == 'logout' )
	{
		$this->logout();
		return;
	}

	      $logged_in  = $this->ensure_login();
	if (! $logged_in ) { return; }

	// get here and admin has logged in OK

	$has_tables = $this->ensure_tables();

	// get here and the tables have been installed

	if ( $list_id && $do )
	{
		// list is known, so perform some action related to it
		if ( $do == 'delete_links'    ) { $this->delete_links($list_id); }
		if ( $do == 'add_bulk_links'  ) { $this->add_bulk_links($list_id); }
		if ( $do == 'add_single_link' ) { $this->add_single_link($list_id); }
		if ( $do == 'delete_list' )
		{
			$delete_args = array( 'list_id' => $list_id );
			$this->delete_list( $delete_args );
		}
		if ( $do == 'modify_list' )
		{
			$modify_args = array( 'list_id' => $list_id );
			$this->modify_list( $modify_args );
		}
		if ( $do == 'edit_list' )
		{
			$edit_args = array( 'list_id' => $list_id );
			$this->edit_list( $edit_args );
		}
	}
	else {
		// otherwise simply show the main, help, or create-list page

		switch( $do )
		{
			case	'help'		: $this->show_help(); break;
			case	'create_list'	: $this->modify_list(); break;
			default			: $this->show_index();
		};
	}

	return;
  }
  // -------------------------------------------------------------------------------
  function add_bulk_links($list_id=0)
  {
	// add links to a list entered through a textarea box

	$select_sql = "SELECT name FROM roller_list WHERE id = $list_id";

	$result = mysql_query($select_sql);

	$list_name = '';
	if ( isset($result) && mysql_num_rows($result) )
	{
		$row = mysql_fetch_array($result);
		$list_name = $row['name'];
	}
	$total_inserts = 0;

	if ( isset( $_POST['bulk_links'] ) && $_POST['bulk_links'] )
	{
		foreach ( split("\n",$_POST['bulk_links']) as $line )
		{
			if ( preg_match( '/^\s*(\w+\:\/\/\S.+?)\s*\|\s*(\S.+?)\s*$/', $line, $m ) )
			{
				$url         = $m[1];
				$anchor_text = $m[2];
				$insert_sql  = "INSERT INTO roller_link SET "
					. "list_id = $list_id, "
					. "url = '$url', "
					. "anchor_text = '$anchor_text' ";
				$inserted = mysql_query($insert_sql);
				if ( $inserted ) { ++$total_inserts; }
			}
		}
	}
	$s = array();
	$s['bulk_link_insertion_message']
		= $total_inserts
		? "Successfully inserted $total_inserts links into '$list_name' list<br/><br/>"
		: "Failed to insert ANY links into '$list_name' list. ".mysql_error()."<br/><br/>";

	$this->show_index($s);

	return;
  }
  // -------------------------------------------------------------------------------
  function add_single_link($list_id=0)
  {
	// add a SINGLE link to a list

	$link_url
		= ( isset( $_POST['link_url'] ) && $_POST['link_url'] )
		? $_POST['link_url'] : '';

	$link_anchor_text
		= ( isset( $_POST['link_anchor_text'] ) && $_POST['link_anchor_text'] )
		? $_POST['link_anchor_text'] : '';

	// backslash any single-quote characters
	$url         = preg_replace( "/\'/", "\\'", $link_url );
	$anchor_text = preg_replace( "/\'/", "\\'", $link_anchor_text );

	$inserted = 0;

	if ( $url && $anchor_text )
	{
		$select_sql	= "SELECT name FROM roller_list WHERE id = $list_id";

		$result = mysql_query($select_sql);

		$list_name = '';
		if ( isset($result) && mysql_num_rows($result) )
		{
			$row = mysql_fetch_array($result);
			$list_name = $row['name'];
		}

		if ( preg_match( '/^\w+\:\/\/.+/', $url, $m ) )
		{
			$insert_sql	= "INSERT INTO roller_link SET "
					. "list_id = $list_id, "
					. "url = '$url', "
					. "anchor_text = '$anchor_text' ";

			$inserted = mysql_query($insert_sql);
		}
	}
	$s = array();
	$s['link_insertion_message']
		= $inserted
		? "Successfully inserted link into '$list_name' list<br/><br/>"
		: "Failed to insert link into '$list_name' list. ".mysql_error()."<br/><br/>";

	$this->show_index($s);

	return;
  }
  // -------------------------------------------------------------------------------
  function show_help( $s=array() )
  {
	$parse_args = array( 's' => $s, 'template' => 'help' );
	$content = $this->parse_template($parse_args);

	$encaps_args = array( 'content' => $content );
	$this->encapsulate( $encaps_args );

	return;
  }
  // -------------------------------------------------------------------------------
  function show_index( $s=array() )
  {
	$s['list_modification_message']
		= isset( $s['list_modification_message'] )
		?	 $s['list_modification_message'] : '';
	$s['list_creation_message']
		= isset( $s['list_creation_message'] )
		?	 $s['list_creation_message'] : '';
	$s['link_insertion_message']
		= isset( $s['link_insertion_message'] )
		?	 $s['link_insertion_message'] : '';
	$s['bulk_link_insertion_message']
		= isset( $s['bulk_link_insertion_message'] )
		?	 $s['bulk_link_insertion_message'] : '';
	$s['list_deletion_message']
		= isset( $s['list_deletion_message'] )
		?	 $s['list_deletion_message'] : '';

	// find all list ID values and prepare a SELECT list
	// -------------------------------------------------
	$select_sql = 'SELECT id, name FROM roller_list';

	$results = mysql_query($select_sql);

	if ( isset($results) && mysql_num_rows($results) )
	{
		$option = array();
		$edit   = array();
		while ( $row = mysql_fetch_array($results) )
		{
			$option[] = "<option value='".$row['id']."'> ".$row['name'];
			$edit[]   = '<div align="left" style="width: 140px; float:left; '
				. 'padding: 2px; border: 0px solid purple;"><b>'
				. $row['name'].'</b></div>'
				. '<div align="left" style="float: left; width: 160px; '
				. 'padding: 2px; border: 0px solid yellow;">'
				. '<a href="'.$this->admin_url
				. '?do=edit_list&list_id='.$row['id']
				. '">Edit / Get Code</a></div>'
				. '<div align="left" style="float: right; width: 80px; '
				. 'padding: 2px; border: 0px solid blue;">'
				. '<a href="'.$this->admin_url
				. '?do=delete_list&list_id='.$row['id']
				. '" onClick="return confirm_delete(\''.$row['name'].'\');'
				. '">Delete</a></div>';
		}
		$s['select_link_list'] = count($option) ? implode($option,"\n") : '';
		$s['edit_link_list']   = count($edit)   ? implode($edit,"\n<br clear='all' />") : '';
	}

	$parse_args = array( 's' => $s, 'template' => 'index' );
	$content = $this->parse_template($parse_args);

	$encaps_args = array( 'content' => $content );
	$this->encapsulate( $encaps_args );

	return;
  }
  // -------------------------------------------------------------------------------
  function delete_list( $args=array() )
  {
	// delete a list and ALL links with it. then redisplay the index page

	$list_id = isset( $args['list_id'] ) ? $args['list_id'] : 0;

	$s = $this->delete_list_do($list_id);

	$this->show_index($s);

	return;
  }
  // -------------------------------------------------------------------------------
  function modify_list( $args=array() )
  {
	// create OR update the properties of a list, then redisplay the index page

	$list_id = isset( $args['list_id'] ) ? $args['list_id'] : 0;

	$s = $this->modify_list_do($list_id);

	$this->show_index($s);

	return;
  }
  // -------------------------------------------------------------------------------
  function edit_list( $args=array() )
  {
	// show the list edit page

	$list_id = isset( $args['list_id'] ) ? $args['list_id'] : 0;
	$update  = isset( $_POST['update'] ) ? $_POST['update'] : 0;

	$s = array( 'list_id' => $list_id );
	if ( $update )
	{
		$s = $this->modify_list_do($list_id);
	}
	$this->show_edit($s);

	return;
  }
  // -------------------------------------------------------------------------------
  function delete_links($list_id=0)
  {
	$s['list_modification_message']
		= isset( $s['list_modification_message'] )
		?	 $s['list_modification_message'] : '';
	$s['delete_link_list']
		= isset( $s['delete_link_list'] )
		?	 $s['delete_link_list'] : '';
	$s['delete_link_button']
		= isset( $s['delete_link_button'] )
		?	 $s['delete_link_button'] : 'No links yet added.';
	$s['list_deletion_message']
		= isset( $s['list_deletion_message'] )
		?	 $s['list_deletion_message'] : '';

	$select_sql = "SELECT name FROM roller_list WHERE id = $list_id";

	$result = mysql_query($select_sql);

	$list_name = '';
	if ( isset($result) && mysql_num_rows($result) )
	{
		$row = mysql_fetch_array($result);
		$list_name = $row['name'];
	}

	$delete_id = array();
	foreach ( $_POST as $key => $value )
	{
		if ( preg_match( '/^delete_link_(\d+)/', $key, $m ) )
		{
			$delete_id[] = $m[1];
		}
	}
	if ( count($delete_id) )
	{
		// one or more links has been selected for deletion
		$delete_links = implode($delete_id,',');
		$delete_sql
			= 'DELETE FROM roller_link WHERE list_id = '.$list_id.' '
			. 'AND id IN ('.$delete_links.') ';

		$deleted = mysql_query($delete_sql);

		$s['list_deletion_message']
			= $deleted
			? "Links successfully deleted from '$list_name'<br/><br/>"
			: "Failed to delete links from '$list_name'. ".mysql_error()."<br/><br/>";
	}
	$s['list_id']   = $list_id;
	$s['list_name'] = $list_name;

	$parse_args = array( 's' => $s, 'template' => 'edit' );
	$content = $this->parse_template($parse_args);

	$encaps_args = array( 'content' => $content );
	$this->encapsulate( $encaps_args );

	return;
  }
  // -------------------------------------------------------------------------------
  function show_edit( $s=array() )
  {
	$s['list_modification_message']
		= isset( $s['list_modification_message'] )
		?	 $s['list_modification_message'] : '';
	$s['delete_link_list']
		= isset( $s['delete_link_list'] )
		?	 $s['delete_link_list'] : '';
	$s['delete_link_button']
		= isset( $s['delete_link_button'] )
		?	 $s['delete_link_button'] : 'No links yet added.';
	$s['list_deletion_message']
		= isset( $s['list_deletion_message'] )
		?	 $s['list_deletion_message'] : '';

	$select_sql = "SELECT * FROM roller_list WHERE id = ".$s['list_id'];

	$result = mysql_query($select_sql);

	$linkrollerurl = LINKROLLERURL;
	$linkrollerurl = preg_replace('/\/+$/','',$linkrollerurl);	// remove any trailing slashes	

	$s['linkrollerurl'] = $linkrollerurl;
	$s['list_name'] = '';
	$s['list_style'] = '';
	$s['list_number'] = 0;

	if ( isset($result) && mysql_num_rows($result) )
	{
		$row = mysql_fetch_array($result);

		$s['list_name']   = $row['name'];
		$s['list_style']  = $row['display_format'];
		$s['list_number'] = $row['display_number'];

		if ( $s['list_style'] )
		{
			$s['vertical_selected']   = $s['list_style'] == 'vertical'   ? 'SELECTED' : '';
			$s['horizontal_selected'] = $s['list_style'] == 'horizontal' ? 'SELECTED' : '';
		}
		if ( isset( $s['list_number'] ) )
		{
			$s['number_0_selected'] = $s['list_number'] == 0 ? 'SELECTED' : '';
			$s['number_1_selected'] = $s['list_number'] == 1 ? 'SELECTED' : '';
			$s['number_2_selected'] = $s['list_number'] == 2 ? 'SELECTED' : '';
			$s['number_3_selected'] = $s['list_number'] == 3 ? 'SELECTED' : '';
			$s['number_4_selected'] = $s['list_number'] == 4 ? 'SELECTED' : '';
		}
	}

	// how many links are there in the list?
	// -------------------------------------
	$select_sql = 'SELECT COUNT( * ) AS count FROM roller_link WHERE list_id = '.$s['list_id'];

	$result = mysql_query($select_sql);
	$total_links = 0;

	if ( isset($result) && mysql_num_rows($result) )
	{
		$row = mysql_fetch_array($result);
		$total_links = $row['count'];
	}

	// fetch all link records and prepare a CHECKBOX list
	// --------------------------------------------------
	$links_per_page = 100;

	$page = isset( $_GET['page'] ) ? $_GET['page'] : 1;
	$links_lower = ( $page - 1 ) * $links_per_page;

	$next_page_url = '';
	$prev_page_url = '';

	$select_sql	= 'SELECT * FROM roller_link WHERE list_id = '.$s['list_id'].' '
			. 'ORDER BY id '
			. 'LIMIT '.$links_lower.','.$links_per_page;

	$results = mysql_query($select_sql);

	if ( isset($results) && mysql_num_rows($results) )
	{
		if ( $links_lower + mysql_num_rows($results) < $total_links )
		{
			// there are more links on higher pages
			$next_page_url	= $this->admin_url.'?do=edit_list&page='.($page+1)
					.'&list_id='.$s['list_id'];
		}
		if ( $page > 1 )
		{
			// there are more links on lower pages
			$prev_page_url	= $this->admin_url.'?do=edit_list&page='.($page-1)
					.'&list_id='.$s['list_id'];
		}

		$delete = array();
		$index = 0;
		while ( $row = mysql_fetch_array($results) )
		{
			++$index;
			$bg = ( $index % 2 == 0 ) ? '' : 'background: #dddddd;';
			$delete[]
				= '<div style="width: 20px; float: left; '.$bg.' border: 0px solid orange;">'
				. '<input type="checkbox" name="delete_link_'.$row['id'].'"></div>'
				. '<div align="left" style="width: 300px; float: left; '
				. $bg.' padding: 2px; border: 0px solid purple;"><b>'
				. $row['url'].'</b></div>'
				. '<div align="left" style="float: right; width: 230px; '
				. $bg.' padding: 2px; border: 0px solid yellow;">'
				. $row['anchor_text'].'</div>';
		}
		if ( count($delete) )
		{
			$s['delete_link_list'] = implode($delete,"\n<br clear='all' />");
			$s['delete_link_button']
				= '<input type="submit" value="Delete Selected URLs" class="button">';
		}
	}
	$s['next_page_link'] = '';
	if ( $next_page_url )
	{
		$s['next_page_link'] = '&nbsp; <a href="'.$next_page_url.'">>> next</a>';
	}
	$s['prev_page_link'] = '';
	if ( $prev_page_url )
	{
		$s['prev_page_link'] = '<a href="'.$prev_page_url.'">prev <<</a> &nbsp; ';
	}
	$s['current_page'] = '';
	if ( $next_page_url || $prev_page_url )
	{
		$s['current_page'] = 'page '.$page;
	}

	$parse_args = array( 's' => $s, 'template' => 'edit' );
	$content = $this->parse_template($parse_args);

	$encaps_args = array( 'content' => $content );
	$this->encapsulate( $encaps_args );

	return;
  }
  // -------------------------------------------------------------------------------
  function modify_list_do($list_id=0)
  {
	// if the list does not exist, create it. else update it

	$list_name   = isset( $_POST['list_name'] )   ? $_POST['list_name'] : '';
	$list_style  = isset( $_POST['list_style'] )  ? $_POST['list_style'] : '';
	$list_number = isset( $_POST['list_number'] ) ? $_POST['list_number'] : '';

	// remove any non-word character from list name
	$list_name = preg_replace( "/[^\w\_]/", '', $list_name );

	if (!( $list_style && isset($list_number) )) { return; }

	$list_exists = 0;

	if ( $list_id ) 
	{
		$select_sql = "SELECT id, name FROM roller_list WHERE id = $list_id ";
	}
	elseif ( $list_name )
	{
		$select_sql = "SELECT id, name FROM roller_list WHERE name = '$list_name' ";
	}
	else {
		return;
	}
	$result = mysql_query($select_sql);

	if ( isset($result) && mysql_num_rows($result) )
	{
		$list_exists = 1;
		if (!( $list_name && $list_id ))
		{
			$row = mysql_fetch_array($result);
			$list_name = $row['name'];
			$list_id   = $row['id'];
		}
	}
	$query = '';

	$s = array( 'list_id' => $list_id );

	if ( $list_exists )
	{
		// UPDATE existing list
		$query =  "UPDATE roller_list SET "
			. ( $list_name ? "name = '$list_name', " : '' )
			. "display_format = '$list_style', "
			. "display_number = '$list_number' "
			. "WHERE ".( $list_id ? "id = $list_id " : "name = '$list_name' " );

		$updated = mysql_query($query);

		$s['list_modification_message']
			= $updated
			? "List '$list_name' successfully modified<br/><br/>"
			: "Failed to modify '$list_name' list. ".mysql_error()."<br/><br/>";
	}
	elseif ( $list_name )
	{
		// INSERT new list
		$query =  "INSERT INTO roller_list SET "
			. "name = '$list_name', "
			. "display_format = '$list_style', "
			. "display_number = '$list_number' ";

		$inserted = mysql_query($query);
		$s['list_creation_message']
			= $inserted
			? "List '$list_name' successfully created<br/><br/>"
			: "Failed to create '$list_name' list. ".mysql_error()."<br/><br/>";
	}

	return $s;
  }
  // -------------------------------------------------------------------------------
  function delete_list_do($list_id=0)
  {
	// fetch the list name
	// -------------------
	$select_sql = "SELECT name FROM roller_list WHERE id = $list_id";

	$result = mysql_query($select_sql);

	$list_name = '';
	if ( isset($result) && mysql_num_rows($result) )
	{
		$row = mysql_fetch_array($result);
		$list_name = $row['name'];
	}

	// delete the entire list, starting with the links
	// -----------------------------------------------
	$delete_sql	= "DELETE FROM roller_link WHERE list_id = $list_id";
	$deleted_links	= mysql_query($delete_sql);
	$deleted_list	= 0;

	$s = array( 'list_id' => $list_id );

	$deleted_list = 0;
	if ( isset($deleted_links) && $deleted_links )
	{
		$delete_sql	= "DELETE FROM roller_list WHERE id = $list_id";
		$deleted_list	= mysql_query($delete_sql);
	}
	$s['list_deletion_message']
		= $deleted_list
		? "List '$list_name' successfully deleted<br/><br/>"
		: "Failed to delete '$list_name' list. ".mysql_error()."<br/><br/>";

	return $s;
  }
  // -------------------------------------------------------------------------------
  function logout()
  {
	// logout and return to the main admin page

	$cookie_name	= 'linkroller_user';
	$cookie_value	= '';

	setcookie( $cookie_name, $cookie_value,
			$this->cookie_expire, $this->cookie_path, $this->cookie_domain );

	$cookie_name	= 'linkroller_auth';
	$cookie_value	= '';

	setcookie( $cookie_name, $cookie_value,
			$this->cookie_expire, $this->cookie_path, $this->cookie_domain );

	$s = array();
	$parse_args = array( 's' => $s, 'template' => 'login' );
	$content = $this->parse_template($parse_args);

	$encaps_args = array( 'content' => $content );
	$this->encapsulate( $encaps_args );

	return;
  }
  // -------------------------------------------------------------------------------
  function ensure_tables()
  {
	// which tables currently exist?

	$tables_exist   = 0;
	$existing_table = array();

	$select_sql = 'SHOW TABLES';

	$results = mysql_query($select_sql);

	if ( isset($results) && mysql_num_rows($results) )
	{
		while ( $table_row = mysql_fetch_array($results) )
		{
			if ( isset( $table_row[0] ) && $table_row[0] )
			{
				$existing_table[ $table_row[0] ] = 1;
			}
		}
	}

	if ( array_key_exists('roller_list',$existing_table) &&
	     array_key_exists('roller_link',$existing_table)
		) {
		++$tables_exist;
	}
	else {
		// attempt to create the pair of tables

		$file_path  = dirname(__FILE__).'/linkroller.sql';
		$file_lines = array();
		$create_sql = '';

		    $openfile = fopen($file_path,'r');
		if( $openfile )
		{
			while ( $loop_line = fgets($openfile) ) { $create_sql .= $loop_line; }
		}
		if ( $create_sql )
		{
			$sql_query = explode(';',$create_sql);

			foreach ( $sql_query as $query )
			{
				if (! preg_match( '/^\s*$/', $query, $m ) )
				{
					mysql_query($query);

					if ( $error = mysql_error() )
					{
						$this->message = mysql_error();
						$this->error();
					}
				}
			}
			$tables_exist = 1;
		}
	}

	return $tables_exist;
  }
  // -------------------------------------------------------------------------------
  function ensure_login()
  {
	// ensure that admin has logged in before doing anything else (uses cookies)

	$cookie_user = isset( $_COOKIE['linkroller_user'] ) ? $_COOKIE['linkroller_user'] : '';
	$cookie_auth = isset( $_COOKIE['linkroller_auth'] ) ? $_COOKIE['linkroller_auth'] : '';

	$defined_username = null;
	$defined_password = null;

	if ( USERNAME ) { $defined_username = USERNAME; }
	if ( PASSWORD ) { $defined_password = PASSWORD; }

	$enc_auth = $defined_password ? md5( $defined_password ) : '';

	$authenticated = 0;

	if (	$defined_username &&
		$cookie_user == $defined_username &&
		$enc_auth &&
		$enc_auth == $cookie_auth ) { ++$authenticated; }

	if (! $authenticated )
	{
		// not authenticated via cookies, so look for form values
		$form_user = isset( $_REQUEST['username'] ) ? $_REQUEST['username'] : '';
		$form_pass = isset( $_REQUEST['password'] ) ? $_REQUEST['password'] : '';

		if (	$defined_username &&
			$form_user &&
			$form_user == $defined_username &&
			$defined_password &&
			$form_pass &&
			$form_pass == $defined_password ) { ++$authenticated; }
	}

	if (! $authenticated )
	{
		// authenticated neither via cookies nor form, so put up login page

		$s = array();
		$parse_args = array( 's' => $s, 'template' => 'login' );
		$content = $this->parse_template($parse_args);

		$encaps_args = array( 'content' => $content );
		$this->encapsulate( $encaps_args );
	}
	else {
		// allow for auto login

		$cookie_name	= 'linkroller_user';
		$cookie_value	= $defined_username;

		setcookie( $cookie_name, $cookie_value,
			$this->cookie_expire, $this->cookie_path, $this->cookie_domain );

		$cookie_name	= 'linkroller_auth';
		$cookie_value	= $enc_auth;

		setcookie( $cookie_name, $cookie_value,
			$this->cookie_expire, $this->cookie_path, $this->cookie_domain );
	}

	return $authenticated;
  }
  // -------------------------------------------------------------------------------
  function parse_template( $args=array() )
  {
	$s        = $args['s'];
	$template = $args['template'];

	if (!( isset($s) && is_array($s) )) { return; }
	if (!( isset( $template ) && $template )) { return; }

	$file_path  = dirname(__FILE__).'/templates/'.$template.'.tpl';
	$file_lines = array();

	    $openfile = fopen($file_path,'r');
	if( $openfile )
	{
		while ( $loop_line = fgets($openfile) )
		{
			preg_match_all( '/\[\%\s+(\S+)\s+\%\]/', $loop_line, $m );

			if ( array_key_exists(0,$m) )
			{
				// one or more tags found with name in $m[1][0], $m[1][1], etc
				foreach ( $m[1] as $tag )
				{
					if ( array_key_exists($tag,$s) )
					{
						$pattern   = '/\[\%\s+'.$tag.'\s+\%\]/';
						$loop_line = preg_replace( $pattern, $s[$tag], $loop_line );
					}
				}
				$file_lines[] = $loop_line;
			}
		}
	}
	$file_content = count($file_lines) ? implode($file_lines,'') : '';

	return $file_content;
  }
  // -------------------------------------------------------------------------------
  function encapsulate( $args=array() )
  {
	$content = isset( $args['content'] ) ? $args['content'] : '';

	$page_content = '';
	if ( $content )
	{
		$style_url = './admin_style.css';

		$usel_url     = 'http://www.ultimatesearchengineloophole.com/';
		$foundry_url  = 'http://www.reviewfoundry.com/';
		$monopoly_url = 'http://www.reviewfoundry.com/ebook/';

		$s = array(
			'page_content' => $content,
			'admin_url' => $this->admin_url,
			'style_url' => $style_url,
			'usel_url' => $usel_url,
			'foundry_url' => $foundry_url,
			'monopoly_url' => $monopoly_url,
		);
		$parse_args = array( 's' => $s, 'template' => 'navigation' );

		$page_content = $this->parse_template($parse_args);	
	}
	$this->content = $page_content;

	return;
  }
  // -------------------------------------------------------------------------------
  function content()
  {
	return isset($this->content) ? $this->content : 'NO CONTENT';
  }
  // -------------------------------------------------------------------------------
  function error()
  {
      print isset( $this->message ) ? $this->message : 'Unknown error';
      exit;
  }
  // -------------------------------------------------------------------------------
  function dump($data) { print '<pre>'; print_r($data); print '</pre>'; exit; }

} // end class

$roller =& new LinkRoller();
$page   = $roller->content();

print $page;
exit;

?>