<?php

error_reporting(E_ALL);

require_once dirname(__FILE__).'/admin/define.php';

class ShowLinks {

  var $dbh;
  var $content;
  var $message;
  var $list_id;
  var $list;

  // -------------------------------------------------------------------------------
  function ShowLinks( $args=array() )
  {
	// connect to the database
	// -----------------------
	$this->establish_db_connection();

	// the script needs to be called with a list 'id' parameter
	// --------------------------------------------------------
	$this->list_id = isset( $_GET['id'] ) ? $_GET['id'] : 0;

	if (! $this->list_id) { return; }

	// create the list of links
	// ------------------------
	$this->create_link_list();

	// all done. roll the credits...
	// -----------------------------

	return;
  }
  // -------------------------------------------------------------------------------
  function create_link_list()
  {
	// grab information about the list
	// -------------------------------
	$this->list = $this->grab_list_info();

	if (!( isset($this->list) && count($this->list) )) { return; }

	// extract single links and format each one
	// ----------------------------------------
	$links = $this->grab_formatted_links();

	if (!( isset($links) && count($links) )) { return; }

	// now join them together as a single string
	// -----------------------------------------
	$link_list = '';

	if ( $this->list['display_format'] == 'vertical' )
	{
		// align links vertically by joining with a <br/> tag
		// --------------------------------------------------
		$link_list = implode($links,"<br/>\n");
	}
	else {
		// create a horizontal row of links separated by &nbsp;
		// ----------------------------------------------------
		$link_list = implode($links,' &nbsp; ');
	}
	// we'll add the link style file to the list of links
	// --------------------------------------------------
	$linkrollerurl  = LINKROLLERURL;				// from define.php
	$linkrollerurl  = preg_replace('/\/+$/','',$linkrollerurl);	// remove any trailing slashes	
	$link_style_url = $linkrollerurl . '/link_style.css';

	// here's our final HTML code that gets 
	// inserted into the blog as a list of links
	// -----------------------------------------
	$this->content	= '<link href="'.$link_style_url.'" rel="stylesheet" type="text/css" />'
			. "\n".$link_list;

	return;
  }
  // -------------------------------------------------------------------------------
  function grab_list_info()
  {
	// extract the list particulars
	// ----------------------------
	$select_sql = "SELECT * FROM roller_list WHERE id = ".$this->list_id;

	$result = mysql_query($select_sql);

	$list = array();
	if ( isset($result) && mysql_num_rows($result) )
	{
		$list = mysql_fetch_array($result);
	}

	return $list;
  }
  // -------------------------------------------------------------------------------
  function grab_formatted_links()
  {
	// have list information, so how many links do we need?
	// ----------------------------------------------------
	$number = $this->list['display_number']
		? $this->list['display_number'] : 1 + mt_rand(0,3);  // 1 or 2 or 3 or 4

	// extract that many links as a random sample
	// ------------------------------------------
	$select_sql	= "SELECT * FROM roller_link "
			. "WHERE list_id = ".$this->list_id." "
			. "ORDER BY RAND() "
			. "LIMIT ".$number;

	$results = mysql_query($select_sql);

	// format each link and store them in an array called $links
	// ---------------------------------------------------------
	$links = array();
	if ( isset($results) && mysql_num_rows($results) )
	{
		while ( $row = mysql_fetch_array($results) )
		{
			// format a single link
			// --------------------
			$formatted_link
				= '<a class="'.$this->list['display_format']	// vertical or horizontal
				. '" href="'.$row['url'].'">'
				. $row['anchor_text'].'</a>';

			// store the formatted link to our array
			// -------------------------------------
			$links[] = $formatted_link;
		}
	}

	return $links;
  }
  // -------------------------------------------------------------------------------
  function establish_db_connection()
  {
	$db_selected = 0;

	$this->dbh = @mysql_connect( DB_HOST, DB_USER, DB_PASS );

	if ( isset($this->dbh) && $this->dbh )
	{
		$db_selected = @mysql_select_db( DB_NAME, $this->dbh );
	}
	if ( !$db_selected )
	{
		$this->message = 'Problem: Sorry, we are unable to connect our database...';
		$this->error();
	}

	return;
  }
  // -------------------------------------------------------------------------------
  function content()
  {
	return isset($this->content) ? $this->content : '';
  }
  // -------------------------------------------------------------------------------
  function error()
  {
      print isset( $this->message ) ? $this->message : 'Unknown error';
      exit;
  }
  // -------------------------------------------------------------------------------
  function dump($data) { print '<pre>'; print_r($data); print '</pre>'; exit; }

} // end class

$showlinks =& new ShowLinks();
$page      = $showlinks->content();

print $page;
exit;

?>